//---------------------------------------------------------------------------
//
// Name:        Project1Frm.cpp
// Author:      Rocco84
// Created:     25/02/2006 19.00.33
// Description: file principale che gestisce tutte le funzioni del programma 
//
//---------------------------------------------------------------------------

#include "Project1Frm.h"
#include <wx/ffile.h>
#include <wx/datetime.h>
#include "wx/popupwin.h"
#include "wx/spinctrl.h"
#include <wx/strconv.h>
#include <windows.h>
#include <wx/textctrl.h>
#include <sstream> 
#include <wx/html/htmprint.h>
#include <wx/wxsmtp.h>
#include "wxSMTP/src/wxbase64.cpp"
#include "wxSMTP/src/wxcmdprot.cpp"
#include "wxSMTP/src/wxemail.cpp"
#include "wxSMTP/src/wxmime.cpp" 
#include "wxSMTP/src/wxsmtp.cpp" 
#include "wxSMTP/src/wxstates.cpp" 
#include <wx/textfile.h>

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// Frame_Principale
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Inizio Tabella degli eventi
BEGIN_EVENT_TABLE(Frame_Principale, wxFrame) //wxFrame  legato alla classe del frame principale
	////Manual Code Start
	////Manual Code End
	EVT_BUTTON(pulsante_somma, Frame_Principale::OnButtonAdd) // effettua l'operazione di somma
	EVT_CLOSE(Frame_Principale::Chiudi_Frame_Principale) // chiude il frame in cui gira il programma
    EVT_BUTTON(azzera_forms, Frame_Principale::Azzera_Forms) // azzera tutti i forms presenti
    EVT_MENU(chiudi_prog,  Frame_Principale::Chiudi_Programma) // evento menu: chiude il programma
    EVT_MENU(content_prog, Frame_Principale::Content_Programma) // visualizza info sul programma
    EVT_BUTTON(button_save, Frame_Principale::saveText)         // salva il testo in un file testuale
    EVT_MENU(apri_database, Frame_Principale::Apri_DB)    // apre il frame inerente il database
    EVT_BUTTON(pulsante_stampa, Frame_Principale::Stampa) // stampa il contenuto dei forms
    EVT_MENU(stampa_form, Frame_Principale::Stampa)       // stampa dal menu file
    EVT_BUTTON(esci, Frame_Principale::Chiudi_Programma)  // skippa il programma
    EVT_BUTTON(manda_email, Frame_Principale::Manda_Email) // invia un report per email prendendo i dati dai forms
END_EVENT_TABLE()
////Fine Tabelle degli eventi

Frame_Principale::Frame_Principale(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

Frame_Principale::~Frame_Principale() {}

void Frame_Principale::CreateGUIControls(void)
{
	//Do not add custom code here
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	this->SetSize(8,8,440,433);
	this->SetTitle(wxT("WxSystem - Rocco Galati"));
	this->Center();
	this->SetIcon(wxNullIcon);
	
	////GUI Items Creation End
    WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Lunghezza"), wxPoint(21,14), wxSize(93,17), 0, wxT("WxStaticText1"));
    
    Calcola_Operazioni = new wxButton(this, pulsante_somma, wxT("Calcola"), wxPoint(170,130), wxSize(75,25), 0, wxDefaultValidator);
    
    Lunghezza = new wxTextCtrl(this, LboxTest_AddText, wxT(""), wxPoint(20,30), wxSize(121,21), 0, wxDefaultValidator );
    
    Risultato = new wxTextCtrl(this, ID_Risultato, wxT(""), wxPoint(20,130), wxSize(121,21), 0, wxDefaultValidator );

    WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Risultato"), wxPoint(21,114), wxSize(93,17), 0, wxT("WxStaticText1"));
    
    WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Larghezza"), wxPoint(21,64), wxSize(93,17), 0, wxT("WxStaticText1"));
    
    Larghezza = new wxTextCtrl(this, ID_Larghezza, wxT(""), wxPoint(20,80), wxSize(121,21), 0, wxDefaultValidator );

    WxButton_clear = new wxButton(this, azzera_forms, wxT("Azzera tutto"), wxPoint(250,130), wxSize(75,25), 0, wxDefaultValidator);

    WxButton_Save = new wxButton(this, button_save, wxT("Salva nel DB"), wxPoint(330,130), wxSize(75,25), 0, wxDefaultValidator);

    WxButton_Print = new wxButton(this, pulsante_stampa, wxT("Stampa"), wxPoint(170,180), wxSize(75,25), 0, wxDefaultValidator);

    WxButton_Esci = new wxButton(this, esci, wxT("Chiudi"), wxPoint(250,180), wxSize(75,25), 0, wxDefaultValidator);
    
    WxButton_Email = new wxButton(this, manda_email, wxT("Invia per mail"), wxPoint(330,180), wxSize(75,25), 0, wxDefaultValidator);
    
    wxMenu *menuFile = new wxMenu;

    // Inizio costruzione barra menu!
    
    wxMenu *helpMenu = new wxMenu;
    helpMenu->Append(content_prog, _T("&About...\tF1"), _T("Visualizza info sul programma"));

    menuFile->Append(apri_database, _T("Database"), _T("Consulta il Database"));
    menuFile->Append(stampa_form, _T("Stampa Form"), _T("Stampa il contenuto dei form"));
    menuFile->Append(chiudi_prog, _T("E&xit\tAlt-X"), _T("Chiudi il programma"));
        
    // appendo il menu alla barra dei menu (Top Bar)
    wxMenuBar *menuBar = new wxMenuBar();
    menuBar->Append(menuFile, _T("&File"));
    menuBar->Append(helpMenu, _T("&Help"));

    // appendo la barra dei menu al frame! (costruzione menu terminata)
    SetMenuBar(menuBar);


#if wxUSE_STATUSBAR
    // creo una status bar per visualizza le label di ogni evento
    CreateStatusBar(2);
    SetStatusText(_T("You are using _wxSystem_ @Rocco Galati"));
#endif // wxUSE_STATUSBAR

}


void Frame_Principale::Chiudi_Frame_Principale(wxCloseEvent& event) 
{
    Destroy();
}

// stampa il contenuto dei forms in formato HTML, visualizza un pop con vari settaggi

void Frame_Principale::Stampa(wxCommandEvent& WXUNUSED(event))
{
    
    wxString numero1 = Lunghezza->GetValue(); // carica il valore della lunghezza
    wxString numero2 = Larghezza->GetValue(); // carica il valore della larghezza
    wxString somma = Risultato->GetValue();   // ... ed anche quello del risultato
    
    // inizio funzione stampa!
    
        wxString html = "<html> \n";  // dichiaro una wxString e la uso per i tag html
        html = html + " <p> \n"; 
        html = html + "Numero 1: <b> " +  numero1 + " </b> <br>Numero 2: "; 
        html = html + "<b>" + numero2 + "</b>\n<br>"; 
        html = html + "Somma: <b> " +  somma + " </b>"; 
        html = html + "</p>"; 
        html = html + " \n</html>"; 

        wxHtmlEasyPrinting easyPrint("Stampa Documento", this); // carico un'interfaccia spartana per la stampa
        easyPrint.SetHeader(wxString("Resoconto Operazioni - Pagina: ") + wxT("@PAGENUM@ di @PAGESCNT@<hr>"), wxPAGE_ALL); 
        easyPrint.PreviewText(html); 
 
} 

 
MyStringClass &MyStringClass::operator + (const MyStringClass &o) 
{ 
      const std::string string;
      MyStringClass hope;
      std::string hope_work(o);
     
      // hope_work << o;
 
  double b,c;
 
  if(hope.From_String(b, string) && hope.From_String(c, hope_work)) 
   {                                                    
      std::string risultato_operazione = hope.To_String((string + hope_work)+2); 
   }
 
return *this; 
}

// Compie i calcoli necessari per ottenere la misura desiderata... 
void Frame_Principale::OnButtonAdd(wxCommandEvent& WXUNUSED(event))
{
   std::string numero1; 
   std::string numero2;  
   
   MyStringClass var; 
    
   //uso il template per gestire le stringhe e convertirle in interi o float! 
   
   numero1 = Lunghezza->GetValue(); // numero1 and numero2 are declared in teh previous class
  
   numero2 = Larghezza->GetValue();
      
  
   if(var.From_String(b, numero1) && var.From_String(c, numero2)) // passo a From_String la stringa caricata ed il double
   {                                                    // se la conversione  fattibile, procedo
      std::string risultato_operazione = var.To_String((b + c)); // To_String ritorna il corretto valore dell'operazione
      Risultato->SetValue(risultato_operazione.c_str()); // mostra il risultato nel form apposito
   }
   else
   {
      wxMessageBox("Attenzione: conversione fallita!\n Inviare un resoconto dell'errore a rocco.g@libero.it");
   }  // se la conversione non  fattibile, Ex: se vengono inseriti caratteri nel form...  
               
}


void Frame_Principale::Azzera_Forms(wxCommandEvent& WXUNUSED(event))
{
    Risultato->Clear();
    Lunghezza->Clear();       // Azzera tutti i forms
    Larghezza->Clear();
}


// Funzione per l'invio delle mail - Attenzione: usa delle librerie non ufficiali!

void Frame_Principale::Manda_Email(wxCommandEvent& WXUNUSED(event))
{
    wxString numero1 = Lunghezza->GetValue(); 
    wxString numero2 = Larghezza->GetValue(); 
    wxString somma = Risultato->GetValue();
   
  // Uso un file di configurazione per far settare all'utente i vari parametri
  
  wxTextFile lettore_file("configurazione.ini"); // punta e prepara il file, ma non lo carica
  
  lettore_file.Open(); // apro il file configurazione.ini e lo carica a tutti gli effetti in memoria!
  
  wxString server_smtp = lettore_file.GetLine(2);   // vado alla riga 3 in realt
  wxString email_mittente = lettore_file.GetLine(3); // stessa cos qui, punta alla riga 4
  wxString email_destinatario = lettore_file.GetLine(4); // ... riga 5 del file di testo *.ini
   
   
    // setta i vari parametri ed invia la mail
       
    wxSMTP *smtp = new wxSMTP(NULL); 
    smtp->SetHost(server_smtp); 
    wxEmailMessage *msg = new wxEmailMessage("Invio Resoconto", 
                                             "Operazioni effettuate\n" 
                                             "Primo Numero: " + numero1 + "Secondo Numero: " + numero2 + "Somma: " + somma + "", 
                                             email_mittente); 
    msg->AddAlternative("<html><body><font face=verdana size=3><b>Invio Resoconto</b><br><br>" 
                        "<font face=verdana size=2>Numero 1: <b>" + numero1 + "</b><br>Numero 2: <b>" + numero2 + "<br></b>Somma: <b>" + somma + "</b><br><br><br><font face=verdana size=1><i>Rocco Galati @rocco.g@libero.it</i></font></html>", 
                        "text","html");  // per client email che supportano il formato HTML
    msg->AddTo(email_destinatario); 
    smtp->Send(msg); 
   
   // fine modulo invio email...
   
  
  lettore_file.Write();  // chiude il file e libera la memoria...
  lettore_file.Close(); // operazioni sul file terminate
 
}


void Frame_Principale::Chiudi_Programma(wxCommandEvent& WXUNUSED(event))
{
    // TRUE forza la chiusura del programma, funziona anche con FALSE come parametro
    Close(TRUE);
}

void Frame_Principale::Content_Programma(wxCommandEvent& WXUNUSED(event))
{
    wxString msg;
    msg.Printf( _T("wxSystem v0.0b realizzato da Rocco Galati.\n")
                _T("Rocco Galati @2006-2007 // All rights reserved! "));

    wxMessageBox(msg, _T("Content realizzazione wxSystem"), wxOK | wxICON_INFORMATION, this);
}


void Frame_Principale::saveText(wxCommandEvent& WXUNUSED(event))
{
    
    wxString numero1 = Lunghezza->GetValue(); 
    wxString numero2 = Larghezza->GetValue(); 
    wxString somma = Risultato->GetValue(); 
    wxDateTime time_file_written = wxDateTime::Now();   
 
    
    wxFFile file(wxT("testo.txt"),"a"); 
    file.Write("Dati Salvati il "); 
    file.Write(time_file_written.Format("%c", wxDateTime::CET).c_str()); // operazione una formattazione della data
    file.Write("\n"); 
    file.Write("Numero 1: "); 
    file.Write(numero1);
    file.Write("\n");
    file.Write("Numero 2: "); 
    file.Write(numero2); 
    file.Write("\n"); 
    file.Write("Somma: "); 
    file.Write(somma); 
    file.Write("\n");
    file.Write("#################");
    file.Write("\n\n");
}


// apre a tutti gli effetti un altro frame... un popup

void Frame_Principale::Apri_DB(wxCommandEvent& WXUNUSED(event))
{
    Frame_Figlio dialog( wxT("Database") );
    dialog.ShowModal();
}

// ----------------------------------------------------------------------------
// inizio codice inerente il frame_figlio                                   
// ----------------------------------------------------------------------------

// Inizio Tabella degli eventi per il frame figlio
BEGIN_EVENT_TABLE(Frame_Figlio, wxDialog)
EVT_BUTTON(apri_database, Frame_Figlio::OnOpenFile)    
EVT_BUTTON(pulsante_uscita, Frame_Figlio::Chiudi_PopUp)    
EVT_BUTTON(stampa_db, Frame_Figlio::Stampa_Database)    
EVT_BUTTON(invia_mail_db, Frame_Figlio::Invia_Email_Database) 
END_EVENT_TABLE()
// Fine Tabella degli eventi per il frame figlio

Frame_Figlio::Frame_Figlio(const wxString& title)
         :wxDialog(NULL, wxID_ANY, title, wxPoint(50,50), wxSize(400,300))
{
   
   Apri_DB = new wxButton(this, apri_database, wxT("Apri Database"), wxPoint(288,10), wxSize(85,25), 0, wxDefaultValidator);
   Database = new wxTextCtrl(this, campo_testo, wxT(""), wxPoint(0,0), wxSize(270,250), wxTE_MULTILINE, wxDefaultValidator); 
   Esci = new wxButton(this, pulsante_uscita, wxT("Esci"), wxPoint(288,130), wxSize(85,25), 0, wxDefaultValidator);
   Stampa = new wxButton(this, stampa_db, wxT("Stampa"), wxPoint(288,50), wxSize(85,25), 0, wxDefaultValidator);
   Email =  new wxButton(this, invia_mail_db, wxT("Invia per mail"), wxPoint(288,90), wxSize(85,25), 0, wxDefaultValidator);

   // overloading Risultato ??? [wxTE_MULTILINE, wxDefaultValidator, ...]

}

void Frame_Figlio::Chiudi_PopUp(wxCommandEvent& WXUNUSED(event))
{
    // TRUE come parametro passato a "Close" forza a chiudere il frame...
    Close(TRUE);
}

void Frame_Figlio::Stampa_Database(wxCommandEvent& WXUNUSED(event))
{
        wxString database = Database->GetValue();
    
        // funzione stampa per il database!
        
        wxString html_database = "<html> \n<font face=verdana size=2>";
        html_database = html_database + " <p> \n"; 
        html_database = html_database + "Numero 1: <b> " +  database + " </b> <br>Numero 2: "; 
        html_database = html_database + " \n</html>"; 

        wxHtmlEasyPrinting easyPrint("Stampa Database", this); 
        easyPrint.SetHeader(wxString("Stampa dell'intero database - Pagina: ") + wxT("@PAGENUM@ di @PAGESCNT@<hr>"), wxPAGE_ALL); 
        easyPrint.PreviewText(html_database); 
 
        // fine funzione stampa per il database...
}


void Frame_Figlio::Invia_Email_Database(wxCommandEvent& WXUNUSED(event))
{
  
  wxString database = Database->GetValue();
   
  wxTextFile lettore_file("configurazione.ini"); // punta al file, lo prepara, ma non lo carica in memoria...
  // Open() carica a tutti gli effetti il contenuto del file in memoria!
  lettore_file.Open(); 

  wxString server_smtp = lettore_file.GetLine(9);   // punta alla riga (n-1) come nella precedente funzione
  wxString email_mittente = lettore_file.GetLine(10);
  wxString email_destinatario = lettore_file.GetLine(11);
   
   
       
    wxSMTP *smtp = new wxSMTP(NULL); 
    smtp->SetHost(server_smtp); 
    wxEmailMessage *msg = new wxEmailMessage("Invio Backup Database", 
                                             "Contenuto Database\n"  + database + "<br>", email_mittente); 
    msg->AddAlternative("<html><body><font face=verdana size=3><b>Invio Backup Database</b><br><br>" 
                        "<font face=verdana size=2>Contenuto Database: <br><b><br>" + database + "</b><br><br><font face=verdana size=1><i>Rocco Galati @rocco.g@libero.it</i></font></html>", 
                        "text","html"); // se il client email supporta il formato HTML
    msg->AddTo(email_destinatario); 
    smtp->Send(msg); 
   
     
  lettore_file.Write(); // libera la memoria e chiude il file
  lettore_file.Close(); // operazioni sul file terminate
 
    
}

// Funzione per la lettura di un qualsiasi stream di un file di testo

void Frame_Figlio::OnOpenFile(wxCommandEvent& event) 
{       
        wxString Data;  // Data  di tipo WxString
        char* afile; 
        wchar_t* buffer; // usare wchar_t al posto di wchar! (come da prototipo di wxMBConvUTF8::MB2WC)
        wxMBConvUTF8 convertitore; // per convertire il formato da UTF-8 allo standard UniCode
        int len = 0, Readlen = 0;
                                                            // seleziona le estensioni ammissibili
        wxFileDialog *fileDialog = new wxFileDialog(this, 
                                                        _("select file to open"),_(""), _(""), 
                                                        _("text files (*.txt)|*.txt|All files (*.*)|*.*")); 
        fileDialog->ShowModal(); // carica l'interfaccia per la selezione del file da aprire
        wxFFile *newFile = new wxFFile(fileDialog->GetPath().c_str()); // punta al percorso del file sull'HD
        
        if( newFile->IsOpened()) // se tutto va bene...
        { 
                len = newFile->Length();  // carica la lunghezza del file 
                afile = new char[len];    // lunghezza del file
                buffer = new wchar_t[len]; 
                Readlen = newFile->Read(afile, len); 
                if (Readlen > 0) 
                { 
                        // int retlen = (int) converter.MB2WC(buffer, afile, len); 
                        convertitore.MB2WC(buffer, afile, len); // MB2WC ritorna la dimensione del buffer
                        wxString Data(buffer); // prototipo: wxString::wxString(const wchar_t* psv);
                        Database->AppendText(Data); // mostra il contenuto del file convertito nel frame
                        
                        // Risultato->SetDefaultStyle(wxTextAttr(*wxRED));
                                                
                       // Risultato->WriteText(wxString::wxString(buffer));    
                } 
                
                else 
                
                { 
                        wxMessageDialog *msg1 = new wxMessageDialog(this, _("Errore nello streaming del file"), 
                                                                                                        _("Impossibile aprire il file!")); 
                        msg1->ShowModal(); 
                } 
        }            
                  // Fine funzione lettura streaming file di testo
} 

 
