/****************************************************************************

 Project     : 
 Author      : 
 Description : 

 VERSION INFORMATION:
 File    : $Source: /home/CVS/wxSMTP/src/wxcmdprot.cpp,v $
 Version : $Revision: 1.7 $
 Date    : $Date: 2004/06/29 11:06:20 $
 Author  : $Author: tavasti $

 History: 
 $Log: wxcmdprot.cpp,v $
 Revision 1.7  2004/06/29 11:06:20  tavasti
 - Added OnResponse handler also for initial state (sometimes OnConnect
   arrives after first data)
 - Minor changes in indentation & comments

 Revision 1.6  2004/05/19 04:06:26  tavasti
 Fixes based on comments from Edwards John-BLUW23 <jedwards@motorola.com>
 - Removed -m486 flags from makefile
 - Added filetypes wav & mp3
 - Removed default arguments from wxmime.cpp (only in .h)
 - Commented out iostream.h includes

 Revision 1.5  2003/11/21 12:36:46  tavasti
 - Makefilet -Wall optioilla
 - Korjattu 'jrkevt' varoitukset pois (Jnyt muutama joita ei saa
   kohtuudella poistettua)

 Revision 1.4  2003/11/14 15:43:09  tavasti
 Sending email with alternatives works

 Revision 1.3  2003/11/13 17:12:15  tavasti
 - Muutettu tiedostojen nimet wx-alkuisiksi

 Revision 1.2  2003/11/07 09:17:40  tavasti
 - Kntyv versio, fileheaderit listty.


****************************************************************************/

//static char cvs_id[] = "$Header: /home/CVS/wxSMTP/src/wxcmdprot.cpp,v 1.7 2004/06/29 11:06:20 tavasti Exp $";



/*
 * Purpose: private wxWindows mail transport implementation
 * Author:  Frank Bu
 * Created: 2002
 */

//#define COUT_DEBUG

#ifdef COUT_DEBUG
#include <iostream.h>
#endif
#include <wx/sckstrm.h>

#include "wxcmdprot.h"

#define SOCKET_ID 1

class wxCmdlineProtocolSocketEventHandler : public wxEvtHandler
{
public:
	wxCmdlineProtocolSocketEventHandler(wxCmdlineProtocol& callback) : m_callback(callback)
	{
	}

	void OnSocketEvent(wxSocketEvent& event)
	{
		m_callback.OnSocketEvent(event);
	}

private:
	wxCmdlineProtocol& m_callback;

	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(wxCmdlineProtocolSocketEventHandler, wxEvtHandler)
  EVT_SOCKET(SOCKET_ID, wxCmdlineProtocolSocketEventHandler::OnSocketEvent)
END_EVENT_TABLE()


wxCmdlineProtocol::wxCmdlineProtocol()
{
	m_pCmdlineProtocolSocketEventHandler = new wxCmdlineProtocolSocketEventHandler(*this);
}

wxCmdlineProtocol::~wxCmdlineProtocol()
{
	delete m_pCmdlineProtocolSocketEventHandler;
}

void wxCmdlineProtocol::SetHost(const wxString& host, const wxString& user, const wxString& password)
{
	m_host = host;
	m_user = user;
	m_password = password;
}

void wxCmdlineProtocol::Connect()
{
	if (IsConnected()) Close();
	SetTimeout(60);
	SetEventHandler(*m_pCmdlineProtocolSocketEventHandler, SOCKET_ID);
	SetNotify(wxSOCKET_CONNECTION_FLAG | wxSOCKET_INPUT_FLAG | wxSOCKET_LOST_FLAG);
	Notify(TRUE);

	// connect
	wxIPV4address addr;
	addr.Hostname(m_host);
	addr.Service(25);  // TODO: perhaps the port should not be hardcoded?
	wxSocketClient::Connect(addr, FALSE);
}

void wxCmdlineProtocol::OnInput(wxSocketEvent& event)
{
	// TODO: implementing response timeout somewhere

	// get data
	const int bufsize = 256;
	char buf[bufsize];
	Read(buf, bufsize);
	m_inputLine += wxString(buf, LastCount());

	// search for a newline
#ifdef COUT_DEBUG
        cout << m_inputLine << endl;
#endif
	while (true) {
		size_t pos = 0;
		while (pos < m_inputLine.Length() - 1) {
			if (m_inputLine[pos] == 13) {
				if (m_inputLine[pos + 1] == 10)
				{
					// line found, evaluate
					EvaluateLine(m_inputLine.Mid(0, pos));

					// adjust buffer
					m_inputLine = m_inputLine.Mid(pos + 2);
					return;
				}
				break;
			}
			pos++;
		}
	}
}

void wxCmdlineProtocol::OnSocketEvent(wxSocketEvent& event)
{
	wxString s = _("OnSocketEvent: ");

	switch(event.GetSocketEvent())
	{
		case wxSOCKET_INPUT:
			OnInput(event);
			break;
		case wxSOCKET_LOST:
			// TODO: error handling
			break;
		case wxSOCKET_CONNECTION:
			OnConnect(event);
			break;
                default:
                        break;
	}
}

void wxCmdlineProtocol::Write(const wxString& msg)
{
#ifdef COUT_DEBUG
    cout << ">>" << msg << "<<" << endl;
#endif
    wxSocketClient::Write(msg.GetData(), msg.Length());
}

