/****************************************************************************

 Project     : 
 Author      : 
 Description : 

 VERSION INFORMATION:
 File    : $Source: /home/CVS/wxSMTP/src/wxemail.cpp,v $
 Version : $Revision: 1.7 $
 Date    : $Date: 2004/05/19 04:06:26 $
 Author  : $Author: tavasti $

 History: 
 $Log: wxemail.cpp,v $
 Revision 1.7  2004/05/19 04:06:26  tavasti
 Fixes based on comments from Edwards John-BLUW23 <jedwards@motorola.com>
 - Removed -m486 flags from makefile
 - Added filetypes wav & mp3
 - Removed default arguments from wxmime.cpp (only in .h)
 - Commented out iostream.h includes

 Revision 1.6  2003/11/21 12:36:46  tavasti
 - Makefilet -Wall optioilla
 - Korjattu 'jrkevt' varoitukset pois (Jnyt muutama joita ei saa
   kohtuudella poistettua)

 Revision 1.5  2003/11/14 15:46:50  tavasti
 Commented out some debug printing

 Revision 1.4  2003/11/14 15:43:09  tavasti
 Sending email with alternatives works

 Revision 1.3  2003/11/13 17:12:15  tavasti
 - Muutettu tiedostojen nimet wx-alkuisiksi

 Revision 1.2  2003/11/07 09:17:40  tavasti
 - Kntyv versio, fileheaderit listty.


****************************************************************************/

//static char cvs_id[] = "$Header: /home/CVS/wxSMTP/src/wxemail.cpp,v 1.7 2004/05/19 04:06:26 tavasti Exp $";

/*
 * Purpose: wxWindows email implementation
 * Author:  Frank Bu
 * Created: 2002
 */
//#include <iostream.h>

#include "wxemail.h"
#include "wxbase64.h"


wxEmailMessage::wxEmailMessage(const wxString& subject, const wxString& text, const wxString& from) :
	m_subject(subject),
	m_text(text),
	m_from(from)
{
}

const wxString& wxEmailMessage::GetFrom()
{
	return m_from;
}

void wxEmailMessage::AddRecipient(const wxString& address)
{
	m_rcptArray.Add(address);
}

void wxEmailMessage::AddTo(const wxString& address)
{
	m_toArray.Add(address);
}

void wxEmailMessage::AddCc(const wxString& address)
{
	m_ccArray.Add(address);
}

void wxEmailMessage::AddBcc(const wxString& address)
{
	m_bccArray.Add(address);
}

void wxEmailMessage::AddFile(const wxFileName& fileName, const wxString mimeMainType, const wxString mimeSubType)
{
	// add new entry
	m_mimeParts.Add(wxMimePart(fileName));
}

void wxEmailMessage::AddAlternative(const wxString data,
                                    const wxString mimeMainType,
                                    const wxString mimeSubType) {
    // Add alternative (normally html, but might there be others?
    m_mimeAlternatives.Add(wxMimePart(data,TRUE,mimeMainType,mimeSubType));    
}

wxRecipientsIterator wxEmailMessage::GetRecipientsIterator()
{
	return wxRecipientsIterator(*this);
}

void wxEmailMessage::Encode(wxOutputStream& out)
{
	// TODO: use only MIME if neccessary
	wxString header;
	wxString cr("\x00d\x00a");
	//wxString cr("/n");
	// TODO: calculate a more random boundary
        
        wxString timestr = wxDateTime::Now().Format("%H%m%M%C%d%S%s%w%W");
	wxString boundary = "---_" + timestr + "-boundary-" + timestr
            + "_---";
        wxString boundary2 = "---_" + timestr + "-02-boundary-02-" 
            + timestr + "_---";
	wxString boundarySep = "--" + boundary + cr;
	wxString boundarySep2 = "--" + boundary2 + cr;
	header << "From: " << m_from << cr;
        if(m_toArray.GetCount() > 0) {
            header << "To: ";
            for(unsigned int i = 0; i < m_toArray.GetCount() ; i++) {
                if(i > 0) header << "," << cr;
                header << m_toArray[i];
            }
            header << cr;
        }
        
        if(m_ccArray.GetCount() > 0) {
            header << "Cc: ";
            for(unsigned int i = 0; i < m_ccArray.GetCount() ; i++) {
                if(i > 0) header << "," << cr;
                header << m_ccArray[i];
            }
            header << cr;
        }

        if(m_bccArray.GetCount() > 0) {
            header << "Cc: ";
            for(unsigned int i = 0; i < m_bccArray.GetCount() ; i++) {
                if(i > 0) header << "," << cr;
                header << m_bccArray[i];
            }
            header << cr;
        }

        header << "Subject: " << m_subject << cr  // TODO: add Date:
	       << "MIME-Version: 1.0" << cr
	       << "Content-Type: multipart/mixed; boundary=\"" << boundary << "\"" << cr
	       << cr
	       << cr
		   << "This is a multi-part message in MIME format" << cr
	       << cr
	       << boundarySep;
        if(m_mimeAlternatives.GetCount() > 0) {
            header << "Content-Type: multipart/alternative; boundary=\"" 
                   << boundary2 << "\"" << cr << cr << boundarySep2;
        }
        header << "Content-Type: text/plain; charset=iso-8859-1" << cr
	       << "Content-Transfer-Encoding: 8bit" << cr
	       << cr
	       << m_text << cr;  
        // TODO: is it possible in MIME message to have a single '.' on a line?
        //cout << ">>" << header << "<<" << endl;
	out.Write((const char*) header.GetData(), header.Length());
	for (size_t i = 0; i < m_mimeAlternatives.GetCount(); i++) {
                // cout << ">>" << boundarySep2 << "<<" << endl;
		out.Write((const char*) boundarySep2.GetData(), 
                          boundarySep2.Length());
		m_mimeAlternatives[i].Encode(out);
	}
        if(m_mimeAlternatives.GetCount() > 0) {
            header = "--" + boundary2 + "--" + cr; 
            //cout << ">>" << header << "<<" << endl;
            out.Write((const char*) header.GetData(), header.Length());
        }

	for (size_t i = 0; i < m_mimeParts.GetCount(); i++) {
            //cout << ">>" << boundarySep << "<<" << endl;
		out.Write((const char*) boundarySep.GetData(), 
                          boundarySep.Length());
		m_mimeParts[i].Encode(out);
	}
	wxString footer = "--" + boundary + "--" + cr + "." + cr;  // TODO: perhaps moving the '.\r\n' sequence to another place
        //cout << ">>" << footer << "<<" << endl;
	out.Write((const char*) footer.GetData(), footer.Length());
}

wxRecipientsIterator::wxRecipientsIterator(const wxEmailMessage& emailMessage) :
	m_emailMessage(emailMessage)
{
	m_rcptCount = 0;
	m_toCount = 0;
	m_ccCount = 0;
	m_bccCount = 0;
}

bool wxRecipientsIterator::HasNext()
{
	if (m_rcptCount < m_emailMessage.m_rcptArray.GetCount() ||
		m_toCount < m_emailMessage.m_toArray.GetCount() ||
		m_ccCount < m_emailMessage.m_ccArray.GetCount() ||
		m_bccCount < m_emailMessage.m_bccArray.GetCount())
	{
		return true;
	}
	return false;
}

wxString wxRecipientsIterator::GetNext()
{
	if (m_rcptCount < m_emailMessage.m_rcptArray.GetCount()) {
		return m_emailMessage.m_rcptArray[m_rcptCount++];
	} else if (m_toCount < m_emailMessage.m_toArray.GetCount()) {
		return m_emailMessage.m_toArray[m_toCount++];
	} else if (m_ccCount < m_emailMessage.m_ccArray.GetCount()) {
		return m_emailMessage.m_ccArray[m_ccCount++];
	} else if (m_bccCount < m_emailMessage.m_bccArray.GetCount()) {
		return m_emailMessage.m_bccArray[m_bccCount++];
	}
	return "";
}

