/****************************************************************************

 Project     : 
 Author      : 
 Description : 

 VERSION INFORMATION:
 File    : $Source: /home/CVS/wxSMTP/src/wxstates.cpp,v $
 Version : $Revision: 1.5 $
 Date    : $Date: 2004/06/29 11:06:20 $
 Author  : $Author: tavasti $

 History: 
 $Log: wxstates.cpp,v $
 Revision 1.5  2004/06/29 11:06:20  tavasti
 - Added OnResponse handler also for initial state (sometimes OnConnect
   arrives after first data)
 - Minor changes in indentation & comments

 Revision 1.4  2003/11/21 12:36:46  tavasti
 - Makefilet -Wall optioilla
 - Korjattu 'jrkevt' varoitukset pois (Jnyt muutama joita ei saa
   kohtuudella poistettua)

 Revision 1.3  2003/11/13 17:12:15  tavasti
 - Muutettu tiedostojen nimet wx-alkuisiksi

 Revision 1.2  2003/11/07 09:17:40  tavasti
 - Kntyv versio, fileheaderit listty.


****************************************************************************/

//static char cvs_id[] = "$Header: /home/CVS/wxSMTP/src/wxstates.cpp,v 1.5 2004/06/29 11:06:20 tavasti Exp $";

/*
 * Purpose: private wxWindows helper classes for SMTP
 * Author:  Frank Bu
 * Created: 2002
 */

#include "wxstates.h"


const InitialState g_initialState;
const ConnectedState g_connectedState;
const HeloState g_heloState;
const SendMailFromState g_sendMailFromState;
const RcptListState g_rcptListState;
const StartDataState g_startDataState;
const DataState g_dataState;


void InitialState::onConnect(wxSMTP& context, wxSocketEvent& event) const
{
	if (event.GetSocketEvent() == wxSOCKET_CONNECTION) {
		context.ChangeState(g_connectedState);
	} else {
		// error
	}
}

void InitialState::onResponse(wxSMTP& context, int smtpCode) const
{
	// Make sure this is same as ConnectedState::onResponse
        if (smtpCode == 220) {
		context.ChangeState(g_heloState);
		// TODO: using some wxWindows function for getting the hostname
		context.Write("HELO localhost\x00d\x00a");
	} else {
		// error
	}
}


void ConnectedState::onResponse(wxSMTP& context, int smtpCode) const
{
        // Make sure this is same as InitialState::onResponse
	if (smtpCode == 220) {
		context.ChangeState(g_heloState);
		// TODO: using some wxWindows function for getting the hostname
		context.Write("HELO localhost\x00d\x00a");
	} else {
		// error
	}
}


void HeloState::onResponse(wxSMTP& context, int smtpCode) const
{
	if (smtpCode == 250) {
		context.ChangeState(g_sendMailFromState);
		context.SendFrom();
	} else {
		// error
	}
}


void SendMailFromState::onResponse(wxSMTP& context, int smtpCode) const
{
	if (smtpCode == 250) {
		context.ChangeState(g_rcptListState);
		context.SendNextRecipient();
	} else {
		// error
	}
}


void RcptListState::onResponse(wxSMTP& context, int smtpCode) const
{
	switch (smtpCode) {
		case 250:
		case 251:
			context.OnRecipientSuccess();
			break;
		case 421:  // service not available
			// error
			break;
		default:
			context.OnRecipientError();
	}
	context.SendNextRecipient();
}


void StartDataState::onResponse(wxSMTP& context, int smtpCode) const
{
	if (smtpCode == 354) {
		context.ChangeState(g_dataState);
		context.SendData();
	}
}


void DataState::onResponse(wxSMTP& context, int smtpCode) const
{
	if (smtpCode == 250) {
		context.OnDataSuccess();
	}
}
